/******************************************************************************
 
	NAME
 
		DiskChange (drive)
 
	SYNOPSIS
 
		DEVICE/A,
 
	LOCATION
 
		Workbench:C
 
	FUNCTION
 
		Tells the filesystem that a diskchange occured. Usually the filesystem
	tries to mount the new hd content then.
 
	INPUTS
 
		DRIVE    --  the drive to alter the buffer allocation of
 
	RESULT
 
	NOTES
 
	EXAMPLE
 
	BUGS
 
	SEE ALSO
 
	INTERNALS
 
	HISTORY
 
******************************************************************************/

#include <exec/memory.h>
#include <dos/dos.h>
#include <dos/exall.h>

#include <proto/dos.h>
#include <proto/exec.h>

#include <stdio.h>

#define	printf	Printf

#include "diskchange_version.h"

static const char version[] = VERSTAG;

#define ARG_TEMPLATE "DEVICE/A"

enum
{
	ARG_DEVICE = 0,
	NOOFARGS
};


int main(void)
{
	struct Library *SysBase=*((struct Library**) 4);
	struct DosLibrary	*DOSBase;
	IPTR   args[NOOFARGS] = { (IPTR)NULL};
	struct RDArgs *rda;
	int    error = RETURN_OK;
	struct MsgPort *FSPort;

	if ((DOSBase=(struct DosLibrary *)OpenLibrary("dos.library",37))!=0)
	{
		rda = ReadArgs(ARG_TEMPLATE, args, NULL);

		if (rda != NULL)
		{
			STRPTR  device = (STRPTR)args[ARG_DEVICE];

			if (FSPort=DeviceProc(device))
			{
				if ((DoPkt(FSPort,ACTION_INHIBIT,DOSTRUE,0,0,0,0))!=DOSFALSE)
				{
					DoPkt(FSPort,ACTION_INHIBIT,DOSFALSE,0,0,0,0);
				}
				else
				{
					PrintFault(IoErr(),"error while inhibiting the device");
				}
			}
			else
			{
				PrintFault(IoErr(),"error while searching the device");
			}
			FreeArgs(rda);
		}
		else
		{
			PrintFault(IoErr(), "DiskChange");
			error = RETURN_FAIL;
		}

		CloseLibrary((struct Library *)DOSBase);
	}
	return error;
}
